/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Wed Mar  5 15:51:02 CET 2003
    copyright            : (C) 2003 by Erwin Rol
    email                : erwin@muffin.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <conio.h>
#include <stdint.h>
#include <ctype.h>
#include <time.h>

#include "mpc8xxbdm.h"
#include "mpc8xxflash.h"
#include "mpc8xxmisc.h"
#include "mpc8xxspr.h"
#include "mpc8xxtarget.h"
#include "mpc8xxmem.h"
#include "mpc8xxI2C.h"


#include "FT2232BDM.h"


#define bbase   0xff000000

unsigned int base_DS1742 = 0x02800000;
unsigned int size_DS1742 = 0x00000800;

unsigned int base_ram_mainboard = 0x00000000;
unsigned int size_ram_mainboard = 0x00800000;

unsigned int base_flash_mainboard = 0xffc00000;
unsigned int size_flash_mainboard = 0x00400000;

unsigned int base_CE1 = 0x05000000;
unsigned int base_CE2 = 0x06000000;

int TDS3EM_plugged_in = 0;
int RTC_onCS2 = 0;
int RTC_onCS6 = 0;

int fastFLASH = 1;

unsigned int option_module_ID = 0;

unsigned int target_buffer_address = 0x4000;
unsigned int target_buffer_size = 8192;
unsigned int prog_address = 0x8000;

char patch_filename[200];
char TDS3EM_FlashRomFileName[200];
char tekROM_filename[200];
char tekRTC_filename[200];
char tekRAM_filename[200];
char tekI2C_filename[200];

unsigned int UPMA_RAMarray[64];
unsigned int UPMB_RAMarray[64];

unsigned int TDS3000_UPMA_RAM_array[] = {
     0x0f0cfc04, 0x00afcc04, 0x0facf000, 0xfffffc45,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0x0f0cfc04, 0x00ffcc04, 0xf0fffc00, 0xf0fffc40,
     0xf0fffc40, 0xfffffc40, 0xfffffc45, 0xffffffff,
     0x0ffcf004, 0x0ffccc84, 0xfffffc04, 0xfffffc84,
     0xfffffc34, 0x0facc004, 0xfffffc04, 0xfffffc05,
     0x0f0cfc00, 0x00afc044, 0x1fbdf405, 0xffffffff,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0x0f0cfc00, 0x00ffc040, 0xf0fffc40, 0xf0fffc40,
     0xf1fffc47, 0xffffffff, 0xffffffff, 0xffffffff,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0x0ffccc04, 0xfffffc04, 0xfffffc84, 0x0ffccc04,
     0xfffffc84, 0xfffffc05, 0xffffffff, 0xffffffff,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0xfffffc07, 0xffffffff, 0xffffffff, 0xffffffff,
    };

unsigned int TDS3000_UPMB_RAM_array[64] =  {
     0x0fff8c04, 0x0eff5c44, 0x00ffcc00, 0x11ffcc47,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0x0fff8c04, 0x0fff0c8c, 0x0fff0c8c, 0x0fff0c0c,
     0x0eff5c44, 0x00ffcc00, 0x00ffccc0, 0x00ffccc0,
     0x00ffcc40, 0x11ffcc47, 0xffffffff, 0xffffffff,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0x0eff8c04, 0x01ff5c44, 0x1fffcc00, 0xffffcc45,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0x0eff8c00, 0x00ff0c48, 0x00ff0c48, 0x00ff0c48,
     0x00ff0c48, 0x00ff0c48, 0x00ff0c48, 0x00ff0c0c,
     0x01ff5c44, 0x1fffcc00, 0xffffcc45, 0xffffffff,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0xc0ffcc04, 0x01ffcc84, 0x7fffcc04, 0xc0ffcc84,
     0x01ffcc04, 0x7fffcc07, 0xffffffff, 0xffffffff,
     0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
     0xffffcc07, 0xffffffff, 0xffffffff, 0xffffffff,
    };

#define PBUF_LEN 0x400000
unsigned char big_buffer[PBUF_LEN];

static void print( const char* s ){
	printf("%s",s);
}

void showUPDarrays ()
{
    read_UPM_RAMarray (0, UPMA_RAMarray);
    print_UPM_RAM_array ("UPMA RAM array is:", UPMA_RAMarray);
    read_UPM_RAMarray (1, UPMB_RAMarray);
    print_UPM_RAM_array ("UPMB RAM array is:", UPMB_RAMarray);
}

void load_UPMarrays ()
{
   write_UPM_RAMarray (0, TDS3000_UPMA_RAM_array);
   write_UPM_RAMarray (1, TDS3000_UPMB_RAM_array);
}

unsigned int tohex (unsigned int x)
{
    unsigned int lo_nibble, hi_nibble;
    lo_nibble = x % 10;
    hi_nibble = x / 10;
    return 16*hi_nibble + lo_nibble;
}

unsigned int HexByteToDec (unsigned int x)
{
    return (10 * (x >> 4) + (x & 0xf));
}

void SetDS1742W (unsigned int address, unsigned int data)
{
    mpc8xx_set_byte(base_DS1742 + address, data);
}

unsigned int GetDS1742W (unsigned int address)
{
    return mpc8xx_get_byte(base_DS1742 + address);
}

void WaitMilliSeconds (long minimum_ms_waittime)
{
    int done = 0;
    long dt;

    stopwatch_set_tstart ();

    do
    {
        dt = stopwatch_how_many_ms_since ();
        if (dt >= minimum_ms_waittime)
            done = 1;
        else
            Sleep (100);
    } while (!done);
}

void TDS3000_set_time_date ()
{
    SYSTEMTIME st;

    GetSystemTime(&st);

    SetDS1742W (0x7f8, 0x80);
    SetDS1742W (0x7f9, tohex(st.wSecond));
    SetDS1742W (0x7fa, tohex(st.wMinute));
    SetDS1742W (0x7fb, tohex(st.wHour));
    SetDS1742W (0x7fc, tohex(st.wDayOfWeek));
    SetDS1742W (0x7fd, tohex(st.wDay));
    SetDS1742W (0x7fe, tohex(st.wMonth));
    SetDS1742W (0x7ff, tohex(st.wYear % 100));
    SetDS1742W (0x7f8, tohex(st.wYear / 100));
    SetDS1742W (0x7f8, 0x00);

    printf ("now is %02d/%02d/%04d %2d:%02d.%02d \n", st.wDay, st.wMonth, st.wYear, st.wHour, st.wMinute, st.wSecond);
}

void get_time_date_as_string (char *s)
{
    SYSTEMTIME st;

    GetSystemTime(&st);
    sprintf (s, "_%04d%02d%02d_%02d%02d%02d", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);
}

char* append_time_date_string_to_string (char *s)
{
    char extension[200];

    strcpy (extension, s + strlen(s) - 4);
    get_time_date_as_string (s + strlen(s) - 4);
    strcat (s, extension);
    return s;
}

int TDS3000_get_battery_flag ()
{
    int battery_flag;
    battery_flag = GetDS1742W (0x7fc) >> 7;
    return battery_flag;
}

void TDS3000_read_RTC (int *array)
{
    int i=0;

    SetDS1742W (0x7f8, 0x40);
    array[i++] = HexByteToDec(GetDS1742W (0x7f9) & 0x7f);
    array[i++] = HexByteToDec(GetDS1742W (0x7fa) & 0x7f);
    array[i++] = HexByteToDec(GetDS1742W (0x7fb) & 0x3f);
    array[i++] = HexByteToDec(GetDS1742W (0x7fc) & 0x07);
    array[i++] = HexByteToDec(GetDS1742W (0x7fd) & 0x3f);
    array[i++] = HexByteToDec(GetDS1742W (0x7fe) & 0x1f);
    array[i++] = HexByteToDec(GetDS1742W (0x7ff) & 0xff);
    array[i++] = HexByteToDec(GetDS1742W (0x7f8) & 0x3f);
    SetDS1742W (0x7f8, 0x00);
}

void TDS3000_show_RTC ()
{
    int array[8];
    TDS3000_read_RTC (array);
    printf ("TDS3000 RTC is at %02d/%02d/%04d %d:%02d.%02d \n", array[4], array[5], 100*array[7] + array[6], array[2], array[1], array[0]);
}


void TDS3000_clear_RTC ()
{
    int i;
    printf ("clearing NVRAM in DS1742W/DS1744W chip at 0x%08x\n", base_DS1742);
    for (i=0; i<0x7f8; i++)
        SetDS1742W (i, 0xff);

    printf ("done\n");
}


#define test_bytes_size 6

int check_RTC_DS1742 (unsigned int test_at_address)
{
    int i, r = 1;
    unsigned int backup_address = base_DS1742;
    int array[8];
    int array2[8];

    base_DS1742 = test_at_address;
    TDS3000_read_RTC (array);

    unsigned int random_bytes[test_bytes_size];
    unsigned int backup_array[test_bytes_size];

    srand(time(0));
    for (i=0; i<test_bytes_size; i++)
        random_bytes[i] = rand() & 0xff;

    for (i=0; i<test_bytes_size; i++)
        backup_array[i] = GetDS1742W (i);

    for (i=0; i<test_bytes_size; i++)
         SetDS1742W (i, random_bytes[i]);

    for (i=0; i<test_bytes_size; i++)
        if (GetDS1742W (i) != random_bytes[i])
            r = 0;

    if (r)
    {
        TDS3000_read_RTC (array);
        WaitMilliSeconds (1200); // it must have ticked one second within 1.2 seconds lapsed in PC
        TDS3000_read_RTC (array2);
        if (array[0] != array2[0])
            r |= 2;
    }

    if (r==3)
    {
        if (TDS3000_get_battery_flag ())
            r |= 4;
    }

    for (i=0; i<test_bytes_size; i++)
         SetDS1742W (i, backup_array[i]);

    base_DS1742 = backup_address;

    return r;
}

uint32_t Get_DWORD_DS1742W (uint32_t address)
{
    uint32_t lw = 0;

    uint8_t *p = (uint8_t*)&lw;
    p += 3;
    for (int i=0; i<4; i++)
       *p-- = GetDS1742W (address++);

    return lw;
}

void Set_DWORD_DS1742W (uint32_t address, uint32_t lw)
{
    uint8_t *p = (uint8_t*)&lw;
    p +=3;
    for (int i=0; i<4; i++)
       SetDS1742W (address++, *p--);
}


#define ENGINE_HOURS_IN_NVRAM   0x07E0
#define MAC_ADDRESS_IN_NVRAM    0x06F0

void edit_hours()
{
    int32_t minutes;

    minutes = Get_DWORD_DS1742W (ENGINE_HOURS_IN_NVRAM);

    printf ("engine hours now is %d minutes = %1.2f hours\n", minutes, ((float)minutes)/60.0);
    printf ("enter new value in hours or enter 0 to skip: ");
    scanf ("%d", &minutes);
    if (minutes > 0)
        Set_DWORD_DS1742W (ENGINE_HOURS_IN_NVRAM, 60 * minutes);
}

void copy_MAC_to_NVRAM (uint8_t *six_bytes)
{
    int i;
    uint32_t address = MAC_ADDRESS_IN_NVRAM;

    printf ("old values: ");
    for (i=0; i<6; i++)
        printf ("%02x:", GetDS1742W (address++));
    printf ("\nnew values: ");
    address -= 6;

    for (i=0; i<6; i++)
        SetDS1742W (address++, *six_bytes++);

    address -= 6;
    for (i=0; i<6; i++)
        printf ("%02x:", GetDS1742W (address++));
    printf ("\n");


}

uint32_t swap_bytes (uint32_t x)
{
    uint8_t b0, b1, b2, b3;
    uint32_t r;

    b0 = x >> 24;
    b1 = x >> 16;
    b2 = x >> 8;
    b3 = x;
    r = b3;
    r <<= 8;
    r += b2;
    r <<= 8;
    r += b1;
    r <<= 8;
    r += b0;

    return r;
}

void do_decode (unsigned int *boot_rom_image, int kk)
{
    unsigned int x, i0;
    int i, j, N, mode=0;

    unsigned int r5, r7, r8;

//    for (i=0; i<10; i++)
//        printf ("%08x ", swap_bytes (boot_rom_image[i]));


    printf ("Start=0x%08x ", swap_bytes (boot_rom_image[kk]));
    printf (" len=0x%08x ", swap_bytes (boot_rom_image[kk+1]));
    printf (" checksum=0x%08x ", swap_bytes (boot_rom_image[kk+2]));

    mode = swap_bytes (boot_rom_image[kk+3]);
    r5 = swap_bytes (boot_rom_image[kk]) - 0xffc00000;

    if (mode == 1)
        r5 += 0x10;

//    r6 = r5 + swap_bytes (boot_rom_image[kk+1]);
    r7 = swap_bytes (boot_rom_image[kk+2]);
    r8 = 0;


    i = 0;
    j = r5 / 4;
    N = swap_bytes (boot_rom_image[kk+1]);

    while (i < (N>>2))
    {
        if (j >= (PBUF_LEN >> 2))
            break;

        x = swap_bytes (boot_rom_image[j++]);

        i++;

        r8 += x;

 //       i0 = x >> 24;
 //       i1 = x >> 16;
 //       i2 = x >> 8;
 //       i3 = x;
 //       fputc (i0 & 0xff, FM_C);
 //       fputc (i1 & 0xff, FM_C);
 //       fputc (i2 & 0xff, FM_C);
 //       fputc (i3 & 0xff, FM_C);
    }

    x = swap_bytes (boot_rom_image[j++]);

    i = N & 3;

    while (i--)
    {
        i0 = (x & 0xff000000) >> 24;
        x <<= 8;
        r8 += i0;
//        fputc (i0 & 0xff, FM_C);
    }

    r8 += 0x1234;
    printf ("re-calculated=0x%08x, err=0x%08x, type=%d \n", r8, r7-r8, mode );
}

uint32_t find_index_for (uint32_t *buffer, uint32_t buf_from, uint32_t buf_end, uint32_t x, int *found)
{
    uint32_t i = buf_from;
    *found = 0;

    x = swap_bytes (x);

    while (i < buf_end)
    {
        if (buffer[i++] == x)
        {
            *found = 1;
            return i-1;
        }
    }
    return i;
}


void print_printable_asc_char (char ch)
{
    if (ch<' ')
        ch = '.';
    if (ch>127)
        ch = '.';
    printf ("%c", (char)ch);
}

void print_printable_asc_string (unsigned char *buffer, int len)
{
    int i;

    for (i=0; i<len; i++)
    {
        print_printable_asc_char (*buffer++);
        if ((i & 0x1f) == 0x1f)
            printf ("\n");
    }
}

unsigned int find_index_for_string (unsigned char *buffer, unsigned int buf_from, unsigned int buf_end, char *pattern, int *found)
{
    uint32_t i = buf_from;
    *found = 0;
    int j = 0;
    int k = strlen(pattern);

    while (i < buf_end)
    {
        if ((buffer[i] == pattern[j]) || ((pattern[j] == '?') && (isdigit(buffer[i]))))
        {
            j++;
            if (j == k)
            {
                *found = 1;
                return i-(k-1);
            }
        }
        else
            j = 0;
        i++;
    }
    return i;

}

unsigned int load_binary_file (char *filename, unsigned char *buffer, unsigned int total)
{
    int r = 0;
    int n, p = 0;
    FILE *F;
    unsigned int chunk = 4096;

    printf ("reading %d bytes from file %s\n", total, filename);
    r = 0;
    p = 0;

    F = fopen (filename, "rb");
    if (F)
    {

        while (total)
        {
            if (total > chunk)
                n = chunk;
            else
                n = total;
            total -= n;
            if( fread(buffer + p, 1, n, F) != n )
            {
                mpc8xx_printf("file read error.");
                r = 0;
                break;
            }
            r += n;
            p += n;
        }
    }
    return r;
}

int save_to_binary_file (char *filename, unsigned char *buffer, unsigned int total)
{
    int r = 0;
    int n, p = 0;
    FILE *F;
    unsigned int chunk = 4096;

    printf ("writing %d bytes to file %s\n", total, filename);

    F = fopen (filename, "wb");
    if (F)
    {
        while (total)
        {
            if (total > chunk)
                n = chunk;
            else
                n = total;
            total -= n;

            if( fwrite(buffer+p, 1, n, F) != n )
            {
                mpc8xx_printf("file write error.");
                r = 0;
                break;
            }
            r += n;
            p += n;
        }
        fclose (F);
    }
    return r;
}


#define MAX_SIZE_LIST_OF_SECTORS 100
void Patch_ROM_MCONFIG ()
{
    uint32_t len;
    uint32_t i1;
    int found = 0;
 //   int got_it = 0;
    FILE *F;
    uint32_t n, p, total;
    int i, r;
    char bc;
    uint32_t Adr=0;

    char filename[200];
    char filename_out[200];
    char ch;

    unsigned char *ch_p;

    unsigned int list_of_flash_chip_sectors_to_erase [MAX_SIZE_LIST_OF_SECTORS];
    int list_index = 0;
  	mpc8xx_flash_bank_t* pFB;
    mpc8xx_flash_sector_t* pFS;
    mpc8xx_flash_sector_t* previously_done_sector;

    len = PBUF_LEN;

    strcpy (filename, tekROM_filename);
    strcpy (filename+strlen(tekROM_filename)-4, "_patchIn");
    strcat (filename, tekROM_filename + strlen(tekROM_filename)-4);

    printf ("you have a main board ROM copy already in file %s? (y/n):", filename);
    ch = getch();
    printf ("%c\n", ch);
    if (ch != 'y')
    {
        printf ("ok, no problem, we will read it first from the scope and make that file now...\n");
        printf ("reading scope main board flash ROM data and saving in file %s\n", filename);
        mpc8xx_mem_save(filename, base_flash_mainboard, size_flash_mainboard);
    }

    if (load_binary_file (filename, big_buffer, len) == len)
        printf ("done...\n");


    do_decode ((uint32_t*)big_buffer, 8);
    do_decode ((uint32_t*)big_buffer, 16);
//    do_decode ((uint32_t*)big_buffer, 0x4000 / 4);
    do_decode ((uint32_t*)big_buffer, 0x40000 / 4);

    bc = '5';
    if ((bc>'0') && (bc<='6'))
    {
        i1 = 0;
        do
        {
            i1 = find_index_for_string (big_buffer, i1, len, "TDS 30??", &found);
            if (found)
            {
                printf ("at address %08x we have:", i1);
                for (i=0; i<16; i++)
                    print_printable_asc_char (big_buffer[i1+i]);

                ch_p = &big_buffer[i1+4+2];
                printf (" make digit %c a %c? (y/n/1/2/3/4/5/6)", *ch_p, bc);
                ch = getch();
                printf ("%c\n", ch);
                switch (ch)
                {
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                    bc = ch;
                    ch = 'y';
                    break;
                }
                if (ch=='y')
                {
                    *ch_p = (unsigned char)bc;
                    if (list_index < MAX_SIZE_LIST_OF_SECTORS)
                    {
                        list_of_flash_chip_sectors_to_erase [list_index++] = i1;
                        printf ("editing that into:");
                        for (i=0; i<16; i++)
                            print_printable_asc_char (big_buffer[i1+i]);
                        printf ("\n");

                    }
                }
                i1++;
            }

        } while (found);
    }

    if (!list_index)
        printf ("nothing to update...\n");
    else
    {
        printf ("refalsh relevant sector(s)? (y/n)");
        ch = getch();
        printf ("%c\n", ch);
        if (ch == 'y')
        {
            int k = list_index;
            previously_done_sector = NULL;

            while (k)
            {
                Adr = base_flash_mainboard + list_of_flash_chip_sectors_to_erase [k-1];
                pFB = mpc8xx_flash_find_bank (Adr, 0);
                pFS = mpc8xx_flash_find_sector (pFB, Adr, 0);

                if (pFS != previously_done_sector)
                {
                    previously_done_sector = pFS;
                    printf("erasing sector for 0x%08x... ", Adr);
                    if(mpc8xx_flash_erase (Adr, 6000, 0) < 0 )
                    {
                        printf("failure erasing flash sector for address 0x%08x\n", Adr);
                        break; /* failure, exit for loop */
                    }
                    else
                        printf ("done\n");
                }
                k--;
            }

            previously_done_sector = NULL;
            k = list_index;
            while (k)
            {
                Adr = base_flash_mainboard + list_of_flash_chip_sectors_to_erase [k-1];

                pFB = mpc8xx_flash_find_bank (Adr, 0);
                pFS = mpc8xx_flash_find_sector (pFB, Adr, 0);

                if (pFS != previously_done_sector)
                {
                    previously_done_sector = pFS;

                    p = 0;
                    total = 1 + pFS->End - pFS->Start;
                    while (total)
                    {
                        if (total > target_buffer_size)
                            n = target_buffer_size;
                        else
                            n = total;

                        printf ("programming %d bytes in sector ID=0x%08x [0x%08x..0x%08x] ", n, pFS->ID, p + pFS->Start, p + pFS->End);
                        mpc8xx_write_block (target_buffer_address, p + big_buffer + pFS->Start - base_flash_mainboard, n);
                        r = mpc8xx_flash_fast_program (target_buffer_address, target_buffer_address+n-1, p + pFS->Start, &Adr, prog_address);
                        if (r==0)
                            printf ("result=OK \r");
                        else
                            printf ("result=not OK\r");
                        p += n;
                        total -= n;
                    }
                    printf ("\n");
                }
                k--;
            }
        }

        strcpy (filename_out, tekROM_filename);
        strcpy (filename_out+strlen(tekROM_filename)-4, "_patchOut");
        strcat (filename_out, tekROM_filename + strlen(tekROM_filename)-4);

        printf ("save buffer as the new file %s (y/n)", filename_out);
        ch = getch();
        printf ("%c\n", ch);
        if (ch == 'y')
        {
            total = size_flash_mainboard;
            p = 0;

            F = fopen (filename_out, "wb");
            while (total)
            {
                if (total > 1024)
                    n = 1024;
                else
                    n = total;
                total -= n;

                if( fwrite(p + (uint8_t*)big_buffer, 1, n, F) != n )
                {
                    mpc8xx_printf("write error.");
                    return;
                }
                p += n;
            }
            fclose (F);

/*
            if (mpc8xx_flash_check_all_is_erased (base_flash_mainboard, size_flash_mainboard, &Adr, 1 ,prog_address) != 0)
                mpc8xx_flash_clear(base_flash_mainboard, size_flash_mainboard, 1);

            r = mpc8xx_flash_program_file(filename_out, base_flash_mainboard, fastFLASH, 400000, 1, target_buffer_address, target_buffer_size, prog_address);
            if (r==0)
                printf ("done\n");
            else
                printf ("failed\n");
*/
        }

        printf ("hard reset? (y/n)");
        ch = getch();
        printf ("%c\n", ch);
        if (ch == 'y')
            mpc8xx_hreset();
    }

}

#define BUF_LEN 0x4000

void Patch_ROM_Toggle_CS2_CS6 ()
{
    uint32_t adr, len;
    uint32_t i1, i2;
    int found1 = 0;
    int found2 = 0;
    int got_it = 0;
    uint32_t temp;
    FILE *F;
    uint32_t n, p, total;
    int r;

    adr = base_flash_mainboard;
    len = BUF_LEN / 4;
    uint32_t* bbig_buffer = (uint32_t*)big_buffer;

    mpc8xx_read_block(adr, big_buffer, BUF_LEN);

    i1 = 0;
    do
    {
        i1 = find_index_for ( bbig_buffer, i1+1, len, 0x3c600280, &found1);
        i2 = find_index_for ( bbig_buffer, i1+1, len, 0x3c600500, &found2);

        if (found1 && found2)
            if (bbig_buffer[i1+1] == swap_bytes (0x60630401))
                if ((bbig_buffer[i2+1] & 0xffff) == (swap_bytes (0x60630801) & 0xffff))
                {
                    printf ("found pattern at 0x%08x and 0x%08x ", 4*i1, 4*i2);
                    printf ("delta = 0x%x\n", 4*(i2 - i1));
                    got_it = 1;
                }
    } while ((!got_it) && found1);
    if (!got_it)
    {
        printf ("did not find it right away, maybe it was already patched and then we will now patch it back to original\n");
        i2 = 0;
        do
        {
            i2 = find_index_for (bbig_buffer, i2+1, len, 0x3c600500, &found1);
            i1 = find_index_for (bbig_buffer, i2+1, len, 0x3c600280, &found2);

            if (found1 && found2)
                if ((bbig_buffer[i2+1] & 0xffff) == (swap_bytes (0x60630801) & 0xffff))
                    if (bbig_buffer[i1+1] == swap_bytes (0x60630401))
                    {
                        printf ("found flipped pattern at 0x%08x and 0x%08x ", 4*i1, 4*i2);
                        printf ("delta = 0x%x\n", 4*(i1 - i2));
                        got_it = 1;
                    }
        } while (!got_it);
    }

    if (!got_it)
        printf ("Error, could not find the right patterns in ROMs\n");
    else
    {
        temp = bbig_buffer[i2];
        bbig_buffer [i2] = bbig_buffer [i1];
        bbig_buffer [i1] = temp;
        temp = bbig_buffer[i2+1];
        bbig_buffer [i2+1] = bbig_buffer [i1+1];
        bbig_buffer [i1+1] = temp;

        total = BUF_LEN;
        p = 0;

        F = fopen (patch_filename, "wb");
        while (total)
        {
            if (total > 1024)
                n = 1024;
            else
                n = total;
            total -= n;

            if( fwrite(p + big_buffer, 1, n, F) != n )
            {
                mpc8xx_printf("write error.");
                return;
            }
            p += n;
        }
        fclose (F);

        r = mpc8xx_flash_program_file(patch_filename, base_flash_mainboard, fastFLASH, 400000, 1, target_buffer_address, target_buffer_size, prog_address);
        if (r==0)
            printf ("done\n");
        else
            printf ("failed\n");
    }

}

unsigned char testI2C (unsigned char *buffer)
{
    int N = 256;

    unsigned char address = 0, last_good = 0;

    printf ("Scanning I2C for modules 0xa0..0xc0, this takes a minute or so...\n");

    for (address = 0xa0; address < 0xc0; address += 2)
    {
        if (I2C_read_buffer (address, 0, buffer, N))
        {
            printf ("I2C EEPROM module 0x%02x found, it holds:\n", address);
            print_printable_asc_string (buffer, N);
            print_buf ("I2C buffer hexdump:", 0, buffer, N);

            last_good = address;
        }
    }
    return last_good;
}

void I2C_menu ()
{
    unsigned short adr = 0;
    unsigned char adr_chip = 0xa0;

    unsigned char buffer[1024];
    char filename[200];
    char ch;

    int i;
    int N = 256;

    adr_chip = testI2C (buffer);

    if (adr_chip)
    {
        strcpy (filename, tekI2C_filename);
        append_time_date_string_to_string (filename);
        save_to_binary_file (filename, buffer, N);
        printf ("shall we make the unit at 0x%02x a nice all options TDS3ENG module? (y/n)", adr_chip);
        ch = getch();

        printf ("%c\n", ch);
        if (ch == 'y')
        {
            for (i=0; i<N; i++)
                buffer[i] = 0xff;

            sprintf ((char*)buffer+0x04, "TDS3ENG");
            sprintf ((char*)buffer+0x54, "v1.0");

            print_printable_asc_string (buffer, N);
            print_buf ("I2C buffer to be written:", 0, buffer, N);

            printf ("\nwriting in I2C module 0x%02x, one minute please...\n", adr_chip);
            if (I2C_write_buffer (adr_chip, adr, buffer, N) == N)
                printf ("TDS3ENG v1.0 written OK in device 0x%02x at its address 0x%04x \n", adr_chip, adr);
            else
                printf ("I2C write error\n");
        }
        else{
            printf ("shall we program it with what's in binary file %s? (y/n)", tekI2C_filename);
            ch = getch();
            printf ("%c\n", ch);
            if (ch == 'y')
            {
                if (load_binary_file (tekI2C_filename, buffer, N) == N)
                {
                    print_printable_asc_string (buffer, N);
                    print_buf ("I2C buffer to be written:", 0, buffer, N);

                    printf ("\nwriting in I2C module 0x%02x, one minute please...\n", adr_chip);
                    if (I2C_write_buffer (adr_chip, adr, buffer, N) == N)
                        printf ("file %s written OK in device 0x%02x at its address 0x%04x \n", tekI2C_filename, adr_chip, adr);
                    else
                        printf ("I2C write error\n");
                }
                else
                    printf ("file i/o error\n");

            }
        }
    }
}

void interactive_debugger ()
{
    char ch;
    int quit = 0;
    unsigned int adr, data;

    printf ("interactive debugger\n");
    while (!quit)
    {
        ch = getch();
        switch (ch)
        {
            case 'a':
                printf ("enter address 0x");
                scanf("%x", &adr);
                break;
            case 'w':
                printf ("0x%08x=0x%08x\n", adr, mpc8xx_get_word(adr));
                adr+=4;
                break;
            case 'h':
                printf ("0x%08x=0x%04x\n", adr, mpc8xx_get_hword(adr));
                adr+=2;
                break;
            case 'b':
                printf ("0x%08x=0x%02x\n", adr, mpc8xx_get_byte(adr));
                adr+=1;
                scanf("%x", &adr);
                break;
            case 'W':
                printf ("address 0x%8x holds ", adr);
                printf ("%08x set to: 0x", mpc8xx_get_word(adr));
                scanf ("%x", &data);
                mpc8xx_set_word(adr, data);
                break;
            case 'H':
                printf ("address 0x%8x holds ", adr);
                printf ("%04x set to: 0x", mpc8xx_get_hword(adr));
                scanf ("%x", &data);
                mpc8xx_set_hword(adr, data);
                break;
            case 'B':
                printf ("address 0x%8x holds ", adr);
                printf ("%02x set to: 0x", mpc8xx_get_byte(adr));
                scanf ("%x", &data);
                mpc8xx_set_byte(adr, data);
                break;
            case 'x':
                mpc8xx_set_spr_s_hword ("MPTPR", 0x0800);
                break;
            case 'q':
                quit = 1;
                break;
        }
    }

}

void print_menu ()
{
    printf ("r main board ROMs read (copy scope to PC file %s)\n", tekROM_filename);
    printf ("? main board ROMs check if it's erased\n");
    printf ("e main board ROMs erase\n");
    printf ("p main board ROMs program (copy PC file %s to scope)\n\n", tekROM_filename);

    if (TDS3EM_plugged_in)
    {
        printf ("R plug-in module ROM read (copy module to PC file %s)\n", TDS3EM_FlashRomFileName);
        printf ("! plug-in module check if it's erased\n");
        printf ("E plug-in module erase\n");
        printf ("P plug-in module program (copy PC file %s to module)\n", TDS3EM_FlashRomFileName);
    }
    printf ("$ generate a file with random MAC address for Ethernet module flash ROM\n\n");

    printf ("c RTC/NVRAM DS1742W read (copy scope to PC file %s)\n", tekRTC_filename);
    printf ("w RTC/NVRAM DS1742W write (copy PC file %s to scope)\n", tekRTC_filename);
    printf ("U RTC/NVRAM DS1742W clear NVRAM data\n");
    printf ("T RTC/NVRAM DS1742W set to UTC\n");
    printf ("b RTC/NVRAM DS1742W show battery flag\n");
    printf ("t RTC/NVRAM DS1742W show time\n");
    printf ("h RTC/NVRAM DS1742W edit engine running hours\n\n");

    printf ("d main board RAM dump to file (copy scope to PC file %s)\n\n", tekRAM_filename);
    printf ("i I2C option module screen dump, upgrade, copy old to file (copy module in scope to PC file %s)\n\n", tekI2C_filename);

    printf ("^ patch main board boot ROMs #1 (toggle roles /CS2 and /CS6, make file %s)\n", patch_filename);
    printf ("* patch main board boot ROMs #2 (edit scope model (bandwidth), make file %s)\n\n", patch_filename);
    printf ("& program patch (file %s) into main board boot ROMs\n", patch_filename);

    printf ("o read option module identifier\n\n");

    printf ("H H_RESET\n");
    printf ("S S_RESET\n");
    printf ("C Continue\n");

    printf ("q quit\n");

    printf ("enter option:");
}

void printtbit (int b)
{

    if (b)
        printf ("1");
    else
        printf ("0");
}

void re_init()
{
    g_immr = bbase;

    mpc8xx_bdm_reset (0, 1);

    if( mpc8xx_bdm_wait_freeze( 10 ) < 0)
    {
        printf("Traget didn't enter FREEZE state\n");
    }

    mpc8xx_print_cpu_info();

    mpc8xx_set_spr_s ("IMMR", g_immr);

    mpc8xx_set_spr_s ("IC_CST", 0b101L << 25);  // reset instruction cache
    mpc8xx_set_spr_s ("IC_CST", 0b110L << 25);  // invalidate all
    mpc8xx_set_spr_s ("IC_CST", 0b001L << 25);  // disable instruction
    mpc8xx_set_spr_s ("IC_CST", 0b010L << 25);  // disable instruction cache

    mpc8xx_set_spr_s ("DC_CST", 0b1010L << 24);  // reset data cache
    mpc8xx_set_spr_s ("DC_CST", 0b1100L << 24); // invalidate all
    mpc8xx_set_spr_s ("DC_CST", 0b0010L << 24); // enable data cache
    mpc8xx_set_spr_s ("DC_CST", 0b0100L << 24); // disable data cache


    mpc8xx_set_spr_s ("PBDIR", 1 << 16); // port B data direction port
    mpc8xx_set_spr_s ("PBPAR", 0); // port B pin assignments
    mpc8xx_set_spr_s_hword ("PCSO", 0); // port C special options
    mpc8xx_set_spr_s_hword ("PCDIR", 0); // port C data direction
    mpc8xx_set_spr_s_hword ("PCPAR", 0); // port C pin assignments
    mpc8xx_set_spr_s_hword ("PDDIR", 0); // port D data direction
    mpc8xx_set_spr_s ("PBDAT", 0); // port B data register

    uint16_t PORTA = mpc8xx_get_spr_s_hword ("PADAT");
    uint32_t PORTB = mpc8xx_get_spr_s ("PBDAT");
    uint16_t PORTC = mpc8xx_get_spr_s_hword ("PCDAT");
    uint16_t PORTD = mpc8xx_get_spr_s_hword ("PDDAT");

    printf ("PORTA = 0x%04x\n", PORTA);
    printf ("PORTB = 0x%08x\n", PORTB);
    printf ("PORTC = 0x%04x\n", PORTC);
    printf ("PORTD = 0x%04x\n", PORTD);

    printf ("portd_bit_8=");
    printtbit (PORTD & 0x0400);
    printf ("\nportd_bit_9=");
    printtbit (PORTD & 0x0800);
    printf ("\nportd_bit_10=");
    printtbit (PORTD & 0x1000);

    printf ("\nportc_bit_10=");
    printtbit (PORTC & 0x0400);

    printf ("\nporta_bit_12=");
    printtbit (PORTA & 4096);
    printf ("\n");


//    have_immr = 1;

    mpc8xx_set_spr_s ("ICTRL", 0x00000007);

    mpc8xx_set_spr_s ("SIUMCR", 0x00610400);
    mpc8xx_set_spr_s ("SYPCR", 0x00610400);

    mpc8xx_set_spr_s_hword ("SWSR", 0x0000);
    mpc8xx_set_spr_s ("SIPEND", 0x00000000);
    mpc8xx_set_spr_s ("SIMASK", 0x00400000);
    mpc8xx_set_spr_s ("SIEL", 0x00000000);
    mpc8xx_set_spr_s ("SIVEC", 0x3c000000);

    mpc8xx_set_spr_s_hword ("TBSCR", 0x0003);

    mpc8xx_set_word (0xFF000320, 0x00000000);
    mpc8xx_set_word (0xFF000324, 0x00000000);
    mpc8xx_set_word (0xFF000328, 0x10000000);
    mpc8xx_set_word (0xFF00032C, 0x00000000);

    mpc8xx_set_spr_s_hword ("PTSCR", 0x0083);

    mpc8xx_set_spr_s ("SCCR", 0x21800000); //SCCR: disable clock output
    mpc8xx_set_spr_s ("PLPRCR", 0x0000d000); // PLPRCR: clear flags

    load_UPMarrays ();
 //   showUPDarrays ();

    mpc8xx_set_spr_s ("TESR",0x00000000);

    mpc8xx_set_spr_s ("PBR0", 0x00000000);
    mpc8xx_set_spr_s ("POR0", 0x00000000);
    mpc8xx_set_spr_s ("PBR1", 0x00000000);
    mpc8xx_set_spr_s ("POR1", 0x00000000);
    mpc8xx_set_spr_s ("PBR2", 0x00000000);
    mpc8xx_set_spr_s ("POR2", 0x00000000);
    mpc8xx_set_spr_s ("PBR3", 0x00000000);
    mpc8xx_set_spr_s ("POR3", 0x00000000);
    mpc8xx_set_spr_s ("PBR4", 0x00000000);
    mpc8xx_set_spr_s ("POR4", 0x00000000);
    mpc8xx_set_spr_s ("PBR5", 0x00000000);
    mpc8xx_set_spr_s ("POR5", 0x00000000);
    mpc8xx_set_spr_s ("PBR6", 0x00000000);
    mpc8xx_set_spr_s ("POR6", 0x00000000);
    mpc8xx_set_spr_s ("PBR7", 0x00000000);
    mpc8xx_set_spr_s ("POR7", 0x00000000);
    mpc8xx_set_spr_s ("PGCRA", 0x00000000);
    mpc8xx_set_spr_s ("PGCRB", 0x00000000);
    mpc8xx_set_spr_s ("PSCR", 0xfe80fe70);
    mpc8xx_set_spr_s ("PIPR", 0x0000ff00);
    mpc8xx_set_spr_s ("PER", 0x00000000);

    mpc8xx_set_spr_s ("DER", 0x72002004);


    mpc8xx_set_spr_s ("OR0", 0xffc00d20);
    mpc8xx_set_spr_s ("BR0", 0xffc00001);   // CS0	boot rom
    mpc8xx_set_spr_s ("OR1", 0x00000000);
    mpc8xx_set_spr_s ("BR1", 0x00000000);   // CS1	??
    mpc8xx_set_spr_s ("OR2", 0xffff8d24);
    mpc8xx_set_spr_s ("BR2", 0x02800401);   // CS2  DS1742
    mpc8xx_set_spr_s ("OR3", 0xff800a00);
    mpc8xx_set_spr_s ("BR3", 0x00000081);   // CS3  RAM
    mpc8xx_set_spr_s ("OR4", 0xff800800);
    mpc8xx_set_spr_s ("BR4", 0x030008c1);   // CS4
    mpc8xx_set_spr_s ("OR5", 0xfffe0912);
    mpc8xx_set_spr_s ("BR5", 0x04000401);   // CS5
    mpc8xx_set_spr_s ("OR6", 0xffff8d36);
    mpc8xx_set_spr_s ("BR6", 0x05008801);   // CS6 expansion module flash? CE1
    mpc8xx_set_spr_s ("OR7", 0xffff8d26);
    mpc8xx_set_spr_s ("BR7", 0x06000401);   // CS7 expansion module ID CE2

    mpc8xx_set_spr_s_hword ("MPTPR", 0x0800);
    mpc8xx_set_spr_s_hword ("MSTAT", 0xffff);
//    mpc8xx_set_spr_s ("MAMR", 0xc0904113);          // MAMR
    mpc8xx_set_spr_s ("MAMR", 0xc0802113);          // MAMR

    mpc8xx_set_spr_s ("MAR", 0x00000088);          // MCR
    mpc8xx_set_spr_s ("MCR", 0x80006810);          // MCR

    mpc8xx_set_spr_s ("MBMR", 0x00301311);          // MBMR

    mpc8xx_set_spr_hword (0x9C0, 0x8001); // reset CPM, clear Dual Port parameter ram

    int n = 10;
    while (n-- && (mpc8xx_get_spr_hword (0x9C0) & 1))
    {
        if (mpc8xx_nop () != 0)
            break;
        Sleep (50);
        printf ("waiting for CP reset... ");
    }
    if (n<=0)
        printf ("timeout!\n");
    else
        printf ("CP reset done\n");

    option_module_ID = mpc8xx_get_byte(0x06000000);
    if ((option_module_ID & 0xf0) == 0x20)
        TDS3EM_plugged_in = 1;

    mpc8xx_flash_configure(base_flash_mainboard, 2, "flash.dev", "AM29LV160DB");

    if (TDS3EM_plugged_in)
        mpc8xx_flash_configure(base_CE1, 1, "flash.dev", "AM29LV800BT");

    mpc8xx_flash_info (40);

    mpc8xx_set_verbose_level(0);

    RTC_onCS2 = check_RTC_DS1742 (base_DS1742);
    if (RTC_onCS2 != 7)
    {
        mpc8xx_set_spr_s ("OR6", 0xffff8d24);   // 8 bit access
        mpc8xx_set_spr_s ("BR6", 0x05000401);   // CS6  on CE1 for DS1742

        RTC_onCS6 = check_RTC_DS1742 (base_CE1);

        if (!RTC_onCS6)
        {
            mpc8xx_set_spr_s ("OR6", 0xffff8d36);   // back to 16 bit access
            mpc8xx_set_spr_s ("BR6", 0x05008801);   // CS6 expansion module flash? CE1
        }
        else
            base_DS1742 = 0x05000000;
    }
    printf ("RTC_onCS2=%d, RTC_onCS6=%d, assuming RTC address is 0x%08x\n", RTC_onCS2, RTC_onCS6, base_DS1742);

    if (((RTC_onCS2 & 4) == 0) && (RTC_onCS2 & 1))
        printf ("WARNING: Empty battery in Dallas DS1742W RTC chip on CS2 (mainboard)!\n");
    if (((RTC_onCS6 & 4) == 0) && (RTC_onCS6 & 1))
        printf ("WARNING: Empty battery in Dallas DS1744W RTC chip on CS6 (CE1)!\n");

}

int main(int argc, char *argv[])
{
	unsigned int adr;
	unsigned int len;
	unsigned int Adr;

	char filename[200];
	char ch;
	int r;

    #define buf_len 0x800
    unsigned char buffer[buf_len];
    unsigned char random_bytes[6];
    int i;

    FILE *F;

    printf ("\nSicco's TDS3000 BDM backdoor utility v2.1 (16 Aug 2021)\n");

    strcpy (TDS3EM_FlashRomFileName, "tekROM_TDS3EM.bin");
    strcpy (patch_filename, "patched_boot_rom.bin");
    strcpy (tekROM_filename, "tekROM.bin");
    strcpy (tekRTC_filename, "tekRTC_DS1742W.bin");
    strcpy (tekRAM_filename, "tekRAM.bin");
    strcpy (tekI2C_filename, "tekI2C.bin");

	mpc8xx_set_print_function( print );



 	if (mpc8xx_bdm_init() >= 0)
    {
        re_init();
        int quit = 0;
        while (!quit)
        {
            if (mpc8xx_bdm_has_power ())
                printf ("P");
            else
                printf ("p");
            if (getFRZ ())

                printf ("F");
            else
                printf ("f");

            if (getRDY ())
                printf ("r");
            else
                printf ("R");


            printf (">");
            ch = getch();
            printf ("%c\n", ch);

            switch (ch)
            {
            case 3: // CTRL-C
            case 27:    // ESC
            case 'Q':
            case 'q':
                quit = 1;
                break;
            case 'I':
                re_init();
                break;
            case 'D':
                interactive_debugger ();
                break;
            case '<':
                base_DS1742 = 0x02800000;
                mpc8xx_set_spr_s ("OR6", 0xffff8d36);   // back to 16 bit access
                mpc8xx_set_spr_s ("BR6", 0x05008801);   // CS6 expansion module flash? CE1
               printf ("base for RTC is 0x%08x\n", base_DS1742);
                break;
            case '>':
                base_DS1742 = 0x05000000;
                mpc8xx_set_spr_s ("OR6", 0xffff8d24);   // 8 bit access
                mpc8xx_set_spr_s ("BR6", 0x05000401);   // CS6  on CE1 for DS1742
                printf ("base for RTC is 0x%08x\n", base_DS1742);
                break;

            case 'T' :
                TDS3000_set_time_date ();
                break;
            case 'c':
                strcpy (filename, "tekNVRAM");
                append_time_date_string_to_string (filename);
                printf ("reading scope RTC/NVRAM DS1742W data and save in file %s\n", filename);
                mpc8xx_mem_save(filename, base_DS1742, size_DS1742);
                break;
            case 'w':
                strcpy (filename, "tekNVRAM.bin");
                printf ("writing scope RTC/NVRAM DS1742W with data from file %s\n", filename);
                mpc8xx_mem_load(filename, base_DS1742, size_DS1742);
                break;
            case 'b':
                printf ("NVRAM DS1742W battery flag is %d\n", TDS3000_get_battery_flag ());
                break;
            case 't':
                TDS3000_show_RTC ();
                break;
           case 'U':
                TDS3000_clear_RTC ();
                break;

            case 'o':
                option_module_ID = mpc8xx_get_byte(0x06000000);
                printf ("option module=%d (0x%02x)\n", option_module_ID, option_module_ID);
                break;


            case '?':
                r = mpc8xx_flash_check_all_is_erased (base_flash_mainboard, size_flash_mainboard, &Adr, 1 ,prog_address);
                if (r==0)
                    printf ("Flash ROMS are fully erased\n");
                else
                    printf ("Flash ROMS are NOT erased\n");

                break;
            case 'r':
                strcpy (filename, tekROM_filename);
                append_time_date_string_to_string (filename);
                printf ("reading scope mainboard flash ROM data and save in file %s\n", filename);
                mpc8xx_mem_save(filename, base_flash_mainboard, size_flash_mainboard);
                break;
            case 's':
                strcpy (filename, tekROM_filename);
                strcat (filename, "_2C_");
                append_time_date_string_to_string (filename);
                printf ("reading scope mainboard flash ROM data and save in file %s\n", filename);
                mpc8xx_mem_save(filename, base_flash_mainboard + 0x2c0000, size_flash_mainboard - 0x2c0000);
                break;
            case 'e':
                mpc8xx_flash_clear(base_flash_mainboard, size_flash_mainboard, 1);
                break;
            case 'p':
                r = mpc8xx_flash_program_file(tekROM_filename, base_flash_mainboard, fastFLASH, 400000, 1, target_buffer_address, target_buffer_size, prog_address);
                if (r==0)
                    printf ("done\n");
                else
                    printf ("failed\n");
                break;

            case '!':
                r = mpc8xx_flash_check_all_is_erased (base_CE1, 0x100000, &Adr, 1 ,prog_address);
                if (r==0)
                    printf ("TDS3EM Flash ROMS are fully erased\n");
                else
                    printf ("TDS3EM Flash ROMS are NOT erased\n");

                break;
            case 'R':
                strcpy (filename, TDS3EM_FlashRomFileName);
                append_time_date_string_to_string (filename);
                printf ("reading scope TDS3EM flash ROM data and save in file %s\n", filename);
                mpc8xx_mem_save(filename, base_CE1, 0x100000);
                break;
            case 'E':
                mpc8xx_flash_clear(base_CE1, 400000, 1);
                break;
            case 'P':
                r = mpc8xx_flash_program_file(TDS3EM_FlashRomFileName, base_CE1, fastFLASH, 400000, 1, target_buffer_address, target_buffer_size, prog_address);
                if (r==0)
                    printf ("done\n");
                else
                    printf ("failed\n");
                break;
            case '$':
                srand(time(0));

                random_bytes[0] = 0x08;     // Tektronix Inc MAC addresses must start with 080011
                random_bytes[1] = 0x00;
                random_bytes[2] = 0x11;

                for (i=3; i<6; i++)
                    random_bytes[i] = rand() & 0xff;

                for (i=0; i<6; i++)
                {
                    printf ("%02x", random_bytes[i]);
                    if (i<5)
                        printf (":");
                }
                printf("\n");

                F = fopen (TDS3EM_FlashRomFileName, "wt");
                for (i=0; i<6; i++)
                {
                    fprintf (F, "%02x", random_bytes[i]);
                    if (i<5)
                        fprintf (F, ":");
                }
                fprintf (F, "%c", 0);
                i = 12+5+1;
                while (i++ < 32)
                {
                    fprintf (F, "%c", 0xff);
                }
                fclose (F);
                printf ("new file %s is created - but not yet programmed!\n", TDS3EM_FlashRomFileName );

                printf ("copy it to NVRAM? (y/n)");
                ch = getch();
                printf ("%c\n", ch);
                if (ch == 'y')
                {
                    copy_MAC_to_NVRAM (random_bytes);
                }
                break;

            case 'd':
                strcpy (filename, tekRAM_filename);
                append_time_date_string_to_string (filename);
                printf ("reading scope mainboard RAM data and save in file %s\n", filename);
                mpc8xx_mem_save(filename, base_ram_mainboard, size_ram_mainboard);
                break;
            case '^':
                Patch_ROM_Toggle_CS2_CS6 ();
                break;
            case '&':
                r = mpc8xx_flash_program_file(patch_filename, base_flash_mainboard, fastFLASH, 400000, 1, target_buffer_address, target_buffer_size, prog_address);
                if (r==0)
                    printf ("done\n");
                else
                    printf ("failed\n");
                break;
               break;
            case '*':
                Patch_ROM_MCONFIG ();
                break;
            case '0':
                adr = 0;
                len = buf_len;
                mpc8xx_read_block(adr, buffer, len);
                print_buf ("RAM_START", adr, buffer, len);
                break;
             case '1':
                adr = base_flash_mainboard;
                len = buf_len;
                mpc8xx_read_block(adr, buffer, len);
                print_buf ("FLASH_ROM_START", adr, buffer, len);
                break;
            case '2':
                adr = base_DS1742;
                len = size_DS1742;
                mpc8xx_read_block(adr, buffer, len);
                print_buf ("NVRAM DS1742", adr, buffer, len);
                break;
            case '3':
                adr = 0xff000100;
                len = 0x40;
                mpc8xx_read_block(adr, buffer, len);
                print_buf ("MMU", adr, buffer, 0x3c);
                break;
            case '4':
                adr = 0xffffc000;
                len = 0x400;
                mpc8xx_read_block(adr, buffer, len);
                print_buf ("FLASH ROM TOP", adr, buffer, len);
                break;
            case '5':
                adr = target_buffer_address;
                len = 0x800;
                mpc8xx_read_block(adr, buffer, len);
                print_buf ("TARGET_BUFFER", adr, buffer, len);
                break;
           case '6':
                adr = prog_address;
                len = 0x80;
                mpc8xx_read_block(adr, buffer, len);
                print_buf ("PROG", adr, buffer, len);
                break;
           case '7':
                adr = base_CE1;
                len = 0x80;
                mpc8xx_read_block(adr, buffer, len);
                print_buf ("CE1 (TDS3EM ROM)", adr, buffer, len);
                break;
           case 'S':
                printf ("S_RESET\n");
                mpc8xx_sreset();
                break;
           case 'H':
                printf ("H_RESET\n");
                mpc8xx_hreset();
                break;
           case 'C':
                printf ("CONINUE\n");
                mpc8xx_continue();
                break;
           case ' ':
                printf ("INTERRUPT\n");
                mpc8xx_interrupt(1);
                break;
           case 'J':
                printf ("RESUME\n");
                mpc8xx_resume();
                break;
           case 'K':
                printf ("SINGLE STEP\n");
                mpc8xx_continue_single_step();
                get_show_regs ();
                break;
           case 'u':
                showUPDarrays ();
                break;
           case 'h':
                edit_hours();
                break;
           case 'i':
                I2C_menu ();
                break;
           case 'F':
                fastFLASH ^= 1;
                printf ("fastFLASH=%d\n", fastFLASH);
                break;
           default:
                printf ("\\nncommand not implemented (%c)\n\n", ch);
                print_menu ();

                break;
            }
        }

        mpc8xx_hreset();

    }
 //   getch();

	return 0;
}
