
#ifndef __MPC8XXI2C_H__
#define __MPC8XXI2C_H__

#ifdef __cplusplus
extern "C" {
#endif

#define I2C_MASK_SDA 0x10
#define I2C_MASK_SCL 0x20

#define I2C_MASK (I2C_MASK_SDA | I2C_MASK_SCL)


void I2C_SET_SDA_TO (int value);
void I2C_SET_SCL_TO (int value);

void I2C_START ();
void I2C_STOP ();


int I2C_GET_SDA ();
int I2C_GET_SCL ();

void I2C_SEND_BIT (int i);
int I2C_READ_BIT ();

int I2C_SEND_BYTE (int x);
void I2C_RECEIVE_BYTE (unsigned char *x);

int I2C_READ (unsigned char I2C_device_address, unsigned char *data, int N);
int I2C_WRITE (unsigned char I2C_device_address, unsigned char *data, int N);
int I2C_WRITE_AP (unsigned char I2C_device_address, unsigned char Register_Address, int WithStop);

int I2C_read_buffer (unsigned char I2C_device_address, unsigned short address_in_device, unsigned char *buffer, int N);
int I2C_write_buffer (unsigned char I2C_device_address, unsigned short address_in_device, unsigned char *buffer, int N);

void I2C_init ();

#ifdef __cplusplus
}
#endif

#endif /* !__MPC8XXI2C_H__ */
